part of stl_generater;

class StlFunctionBlock extends StlBlock{
  final String type = FC;
  final String STLREAR = 'END_FUNCTION';

  String get stlCode {
    var networksPCode=networks.fold(head.stlCode, (str,network)=>'$str${network.stlCode}');
    return networksPCode+STLREAR;
  }

  String get pCode{
    return networks.fold(head.pCode, (str,network)=>'$str\n${network.pCode}')
        +'\n$PCODE_END';
  }

  StlFunctionBlock(String text, Map<String,String> template):super(template){
    var reg = new RegExp(r'\n[ \f\t\v]*(//)?[ \f\t\v]*@variant[ \f\t\v]*:');
    List<String> lines = text.split(reg);
    if(lines.length<=1){
      return;
    }
    var headstr = lines.removeAt(0);
    head = new StlFunctionHead(headstr,this);
    if(!head.isValid){
      return;
    }

    networks = <StlNetwork>[];
    lines.forEach((line){
      var network = new StlNetwork(line,this);
      if(network.isValid){
        _valid=true;
        networks.add(network);
      }
    });

  }
}