import 'dart:html';
import 'dart:collection';
import 'package:stl_generater/stl_generater.dart';

var stlconvert=new StlGenerater(scaleTemplate);
bool toolDisplay = false;
bool regIntroDisplay = false;
TextAreaElement pcode = query('#pcode');
TextAreaElement stl = query('#stl');

int main() {
  var convertBtn = query('#genstl');
  convertBtn.onClick.listen(convert);

  var showToolsBtn = query('#showCustom');
  showToolsBtn.onClick.listen((e){
    toolDisplay=!toolDisplay;
    DivElement replArea = query('#replArea');
    replArea.style.display = toolDisplay ? 'block' : 'none';
	pcode.style.height = toolDisplay ? '25em' : '35em';
  });
  //
  return 0;
}

bool convert(Event e){
  stlconvert.parse(pcode.value);
  if(stlconvert.isValid){
    pcode.value = stlconvert.pCode;
    stl.value = stlconvert.stlCode;
  }else{
    window.alert('输入有误，无法转换');
  }
}
const String input="""
在下方@GoosyGenerater @EndGoosyGenerater 两行之间依照例子录入转换数据，然后点击“生成”按钮。
每一转换用 // @开头即可，titlecomment一项放在最后并可以多行

// @GoosyGenerater function:FC块名, title:FC块标题
// FC块说明，可多行
// @variant:PTS762,piw:676,range:Press16,title:press 762,comment: 多行注释
压力转换 762
convert AI of press
// @variant:PTS772,piw:680,range:Press16,title:press 772,comment:压力转换 单行注释
// @variant:TTS271,piw:842,range:Temperature100,title:TT-S271,comment:泵温度
// @variant:VTS272,piw:844,range:Vibration,title:VT-S272,comment:泵振动
// @variant:LTS273,piw:846,range:LTS273,title:LT-S273,comment:液位
0-2米
// @EndGoosyGenerater
""";

